import type { TextEncodeChannels, WithDefaultEncode, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, BasicEncoderSpecMap } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class TextSemanticMark extends SemanticMark<BasicEncoderSpecMap['text'], TextEncodeChannels> {
    static readonly type = PlotMakType.text;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['text'], TextEncodeChannels>, TextEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: TextEncodeChannels, option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['text'], TextEncodeChannels>, TextEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<BasicEncoderSpecMap['text'], TextEncodeChannels>): GenerateBaseEncodeSpec<BasicEncoderSpecMap['text']>;
}
