import { SemanticMark } from "./semantic-mark";

import { GrammarMarkType } from "@visactor/vgrammar-core";

import { isArray } from "@visactor/vutils";

import { PlotMakType } from "./enums";

export class Rule extends SemanticMark {
    constructor(id) {
        super(PlotMakType.rule, id);
    }
    setMarkType() {
        return GrammarMarkType.rule;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f;
        const markEncoder = this.convertSimpleMarkEncode(encode);
        let res;
        return isArray(null === (_a = markEncoder.x) || void 0 === _a ? void 0 : _a.field) ? (res.x = {
            field: markEncoder.x.field[0],
            scale: markEncoder.x.scale
        }, res.x1 = {
            field: markEncoder.x.field[1],
            scale: markEncoder.x.scale
        }) : res.x = res.x1 = markEncoder.x, isArray(null === (_b = markEncoder.y) || void 0 === _b ? void 0 : _b.field) ? (res.y = {
            field: markEncoder.y.field[0],
            scale: markEncoder.y.scale
        }, res.y1 = {
            field: markEncoder.y.field[1],
            scale: markEncoder.y.scale
        }) : res.y = res.y1 = markEncoder.y, markEncoder.color || markEncoder.group ? res.stroke = null !== (_c = markEncoder.color) && void 0 !== _c ? _c : markEncoder.group : res.stroke = null !== (_e = null === (_d = this.spec.style) || void 0 === _d ? void 0 : _d.stroke) && void 0 !== _e ? _e : null === (_f = this.getPalette()) || void 0 === _f ? void 0 : _f[0], 
        res;
    }
}

Rule.type = PlotMakType.rule;
//# sourceMappingURL=rule.js.map